commit 46846fc1f6254cb6a1ef14babc40fcae9f5baea1
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Dec 5 12:18:39 2025 +0000

    taint: better tracking for dns lookup results

diff --git a/src/src/acl.c b/src/src/acl.c
index be61fc953..b3c45668a 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -1435,7 +1435,7 @@ tree_node *t;
 const uschar *found;
 int priority, weight, port;
 dns_answer * dnsa;
-dns_scan dnss;
+dns_scan dnss = {0};
 dns_record *rr;
 int rc, type, yield;
 #define TARGET_SIZE 256
@@ -1584,7 +1584,7 @@ be authorized. (This is an odd configuration because weight=2 target=. is
 equivalent to weight=1, but we check for it in order to keep load off the
 root name servers.) Note that dn_expand() turns "." into "". */
 
-if (Ustrcmp(target, "") == 0)
+if (!*target)
   {
   yield = CSA_FAIL_NOADDR;
   goto out;
diff --git a/src/src/auths/dovecot.c b/src/src/auths/dovecot.c
index 118e95f29..c9fdc0ea9 100644
--- a/src/src/auths/dovecot.c
+++ b/src/src/auths/dovecot.c
@@ -298,7 +298,10 @@ if (ob->server_tls)
   {
   union sockaddr_46 interface_sock;
   EXIM_SOCKLEN_T size = sizeof(interface_sock);
+
+  /* Large (64k if DANE supported) */
   smtp_connect_args conn_args = { .host = &host };
+
   tls_support tls_dummy = { .sni = NULL };
   uschar * errstr;
 
diff --git a/src/src/dns.c b/src/src/dns.c
index 5ed896b38..6b527ef00 100644
--- a/src/src/dns.c
+++ b/src/src/dns.c
@@ -318,6 +318,20 @@ dnss_inc_aptr(const dns_answer * dnsa, dns_scan * dnss, unsigned delta)
 return dnsa_bad_ptr(dnsa, dnss->aptr += delta);
 }
 
+static int
+dns_rr_expand_taint(const uschar * msg, const uschar * eom,
+  const uschar * comp_dn, dns_scan * dnss)
+{
+uschar buf[DNS_MAXNAME];
+int ret;
+
+if ((ret = dn_expand(msg, eom, comp_dn,
+		    (DN_EXPAND_ARG4_TYPE) buf, sizeof(buf))) < 0)
+  return ret;
+dnss->srr.name = string_copy_taint(buf, GET_TAINTED);
+return ret;
+}
+
 /*************************************************
 *       Get next DNS record from answer block    *
 *************************************************/
@@ -339,6 +353,7 @@ dns_record *
 dns_next_rr(const dns_answer * dnsa, dns_scan * dnss, int reset)
 {
 const HEADER * h = (const HEADER *)dnsa->answer;
+const uschar * eom = dnsa->answer + dnsa->answerlen;
 int namelen;
 
 char * trace = NULL;
@@ -361,9 +376,9 @@ if (reset != RESET_NEXT)
   while (dnss->rrcount-- > 0)
     {
     TRACE trace = "Q-namelen";
-    namelen = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen,
-      dnss->aptr, (DN_EXPAND_ARG4_TYPE) &dnss->srr.name, DNS_MAXNAME);
-    if (namelen < 0) goto null_return;
+    /*TTT*/
+    if ((namelen = dns_rr_expand_taint(dnsa->answer, eom, dnss->aptr, dnss)) <0)
+      goto null_return;
     /* skip name & type & class */
     TRACE trace = "Q-skip";
     if (dnss_inc_aptr(dnsa, dnss, namelen+4)) goto null_return;
@@ -392,9 +407,10 @@ if (reset != RESET_NEXT)
     while (dnss->rrcount-- > 0)
       {
       TRACE trace = "A-namelen";
-      namelen = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen,
-        dnss->aptr, (DN_EXPAND_ARG4_TYPE) &dnss->srr.name, DNS_MAXNAME);
-      if (namelen < 0) goto null_return;
+      /*TTT*/
+      if (  (namelen = dns_rr_expand_taint(dnsa->answer, eom, dnss->aptr, dnss))
+	  < 0)
+	goto null_return;
 
       /* skip name, type, class & TTL */
       TRACE trace = "A-hdr";
@@ -426,9 +442,9 @@ if (dnss->rrcount-- <= 0) return NULL;
 (something safe). */
 
 TRACE trace = "R-namelen";
-namelen = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, dnss->aptr,
-  (DN_EXPAND_ARG4_TYPE) &dnss->srr.name, DNS_MAXNAME);
-if (namelen < 0) goto null_return;
+/*TTT*/
+if ((namelen = dns_rr_expand_taint(dnsa->answer, eom, dnss->aptr, dnss)) < 0)
+  goto null_return;
 
 /* Move the pointer past the name and fill in the rest of the data structure
 from the following bytes.  We seem to be assuming here that the RR blob passed
@@ -482,16 +498,16 @@ Scan the whole AUTHORITY section, since it may contain other records
 Return: name for the authority, in an allocated string, or NULL if none found */
 
 static const uschar *
-dns_extract_auth_name(const dns_answer * dnsa)	/* FIXME: const dns_answer */
+dns_extract_auth_name(const dns_answer * dnsa)
 {
-dns_scan dnss;
+dns_scan dnss = {0};
 const HEADER * h = (const HEADER *) dnsa->answer;
 
 if (h->nscount && h->aa)
   for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_AUTHORITY);
        rr; rr = dns_next_rr(dnsa, &dnss, RESET_NEXT))
     if (rr->type == (h->ancount ? T_NS : T_SOA))
-      return string_copy(rr->name);
+      return string_copy(rr->name);	/*TTT*/
 return NULL;
 }
 
@@ -750,7 +766,7 @@ bother doing a separate lookup; if not found return a forever TTL.
 time_t
 dns_expire_from_soa(dns_answer * dnsa, int type)
 {
-dns_scan dnss;
+dns_scan dnss = {0};
 
 if (fake_dnsa_len_for_fail(dnsa, type))
   for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_AUTHORITY);
@@ -1046,7 +1062,7 @@ for (int i = 0; i <= dns_cname_loops; i++)
   {
   uschar * data;
   dns_record cname_rr, type_rr;
-  dns_scan dnss;
+  dns_scan dnss = {0};
 
   /* DNS lookup failures get passed straight back. */
 
@@ -1087,7 +1103,7 @@ for (int i = 0; i <= dns_cname_loops; i++)
 	  )
 #endif
        )
-        *fully_qualified_name = string_copy_dnsdomain(rr_name);
+        *fully_qualified_name = string_copy_dnsdomain(rr_name);	/*TTT*/
     }
 
   /* If any data records of the correct type were found, we are done. */
@@ -1111,7 +1127,7 @@ for (int i = 0; i <= dns_cname_loops; i++)
     }
 
   /* DNS data comes from the outside, hence tainted */
-  data = store_get(256, GET_TAINTED);
+  data = store_get(256, GET_TAINTED);				/*TTT alloc*/
   if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen,
       cname_rr.data, (DN_EXPAND_ARG4_TYPE)data, 256) < 0)
     {
@@ -1120,6 +1136,13 @@ for (int i = 0; i <= dns_cname_loops; i++)
     }
   name = data;
 
+  for (int i = 256-50; i > 0; i--)	/* Usually much smaller, so find end */
+    if (!*data++)
+      {
+      store_release_above(data);	/* and release excess allocation */
+      break;
+      }
+
   if (!dns_is_secure(dnsa))
     secure_so_far = FALSE;
 
@@ -1239,8 +1262,8 @@ switch (type)
     uschar * namesuff, * tld;
     int priority, dummy_weight, port, limit, rc, i;
     BOOL ipv6;
-    dns_record *rr;
-    dns_scan dnss;
+    dns_record * rr;
+    dns_scan dnss = {0};
 
     DEBUG(D_dns) debug_printf_indent("CSA lookup of %s\n", name);
 
@@ -1336,7 +1359,7 @@ switch (type)
 	/* If it's making an interesting assertion, return this response. */
 	if (port & 1)
 	  {
-	  *fully_qualified_name = namesuff + 1;
+	  *fully_qualified_name = namesuff + 1;	/*TTT*/
 	  return DNS_SUCCEED;
 	  }
 	}
diff --git a/src/src/dnsbl.c b/src/src/dnsbl.c
index dc4a0bea0..ac3e017e9 100644
--- a/src/src/dnsbl.c
+++ b/src/src/dnsbl.c
@@ -70,7 +70,7 @@ one_check_dnsbl(uschar *domain, uschar *domain_txt, uschar *keydomain,
   int defer_return)
 {
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 tree_node *t;
 dnsbl_cache_block *cb;
 int old_pool = store_pool;
@@ -363,6 +363,7 @@ if (cb->rc == DNS_SUCCEED)
 	  int len = (rr->data)[0];
 	  if (len > 511) len = 127;
 	  store_pool = POOL_PERM;
+	  /*TTT*/
 	  cb->text = string_copyn_taint(CUS (rr->data+1), len, GET_TAINTED);
 	  store_pool = old_pool;
 	  break;
diff --git a/src/src/functions.h b/src/src/functions.h
index 49ed1064d..ec13c544e 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -590,7 +590,7 @@ extern uschar *string_base62_32(unsigned long int);
 extern uschar *string_base62_64(unsigned long int);
 extern gstring *string_catn(gstring *, const uschar *, int) WARN_UNUSED_RESULT;
 extern int     string_compare_by_pointer(const void *, const void *);
-extern uschar *string_copy_dnsdomain(uschar *);
+extern uschar *string_copy_dnsdomain(const uschar *);
 extern uschar *string_copy_malloc(const uschar *);
 extern uschar *string_dequote(const uschar **);
 extern uschar *string_format_size(int, uschar *);
@@ -1145,8 +1145,9 @@ return item
 /* Use store_malloc for DNSA structs, and explicit frees. Using the same pool
 for them as the strings we proceed to copy from them meant they could not be
 released, hence blowing 64k for every DNS lookup. That mounted up. With malloc
-we do have to take care over marking tainted all copied strings.  A separate pool
-could be used and would handle that implicitly. */
+we do have to take care over marking tainted all copied strings.
+A separate pool could be used and could handle taint implicitly - but we would
+want to support independent free ops, not limited to stacked alloc/release */
 
 #define store_get_dns_answer() store_get_dns_answer_trc(CUS __FUNCTION__, __LINE__)
 
diff --git a/src/src/host.c b/src/src/host.c
index 4c513e28c..95694635a 100644
--- a/src/src/host.c
+++ b/src/src/host.c
@@ -180,7 +180,7 @@ uschar *adds;
 uschar **alist;
 struct hostent *yield;
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 
 DEBUG(D_host_lookup)
   debug_printf_indent("using host_fake_gethostbyname for %s (%s)\n", name,
@@ -1587,7 +1587,7 @@ uschar **aliases;
 uschar *ordername;
 const uschar *list = host_lookup_order;
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 
 sender_host_dnssec = host_lookup_deferred = host_lookup_failed = FALSE;
 
@@ -1662,6 +1662,7 @@ while ((ordername = string_nextinlist(&list, &sep, NULL, 0)))
         /* If an overlong response was received, the data will have been
         truncated and dn_expand may fail. */
 
+	/*TTT*/
         if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen,
              US rr->data, (DN_EXPAND_ARG4_TYPE)(s), ssize) < 0)
           {
@@ -2286,7 +2287,7 @@ for (; i >= 0; i--)
   int type = types[i];
   int randoffset = i == (whichrrs & HOST_FIND_IPV4_FIRST ? 1 : 0)
     ? 500 : 0;  /* Ensures v6/4 sort order */
-  dns_scan dnss;
+  dns_scan dnss = {0};
 
   int rc = dns_lookup_timerwrap(dnsa, host->name, type, fully_qualified_name);
   lookup_dnssec_authenticated = !dnssec_request ? NULL
@@ -2389,7 +2390,7 @@ for (; i >= 0; i--)
       if (thishostlast == NULL)
 	{
 	if (strcmpic(host->name, rr->name) != 0)
-	  host->name = string_copy_dnsdomain(rr->name);
+	  host->name = string_copy_dnsdomain(rr->name);	/*TTT*/
 	host->address = da->address;
 	host->sort_key = host->mx * 1000 + random_number(500) + randoffset;
 	host->status = hstatus_unknown;
@@ -2530,7 +2531,7 @@ BOOL srv_smtps = FALSE;
 #endif
 int rc = DNS_FAIL, ind_type = 0, yield;
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 BOOL dnssec_require, dnssec_request;
 dnssec_status_t dnssec;
 
@@ -2784,7 +2785,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
   int port = PORT_NONE;		/* MX lookups get PORT_NONE */
   const uschar * s = rr->data;	/* MUST be unsigned for GETSHORT */
   host_item * next;
-  uschar data[256];
+  uschar data[256];	/*TTT*/
 
   if (rr_bad_size(rr, sizeof(uint16_t))) continue;
   GETSHORT(precedence, s);      /* Pointer s is advanced */
@@ -2811,8 +2812,10 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
 
   /* Get the name of the host pointed to. */
 
-  (void)dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, s,
-    (DN_EXPAND_ARG4_TYPE)data, sizeof(data));
+  /*TTT*/
+  if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, s,
+      (DN_EXPAND_ARG4_TYPE)data, sizeof(data)) < 0)
+    continue;
 
   /* Check that we haven't already got this host on the chain; if we have,
   keep only the lower precedence. This situation shouldn't occur, but you
@@ -2851,7 +2854,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
   before the first block, copy the first block's data to a new second block. */
 
   next = last ? store_get(sizeof(host_item), GET_UNTAINTED) : host;
-  next->name = string_copy_dnsdomain(data);
+  next->name = string_copy_dnsdomain(data);	/*TTT*/
   next->address = NULL;
   next->port = port;
   next->mx = precedence;
@@ -3210,7 +3213,7 @@ switch (rc)
       {
       DEBUG(D_transport)
 	{
-	dns_scan dnss;
+	dns_scan dnss = {0};
 	for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	     rr = dns_next_rr(dnsa, &dnss, RESET_NEXT))
 	  if (rr->type == T_TLSA && rr->size > 3)
diff --git a/src/src/lookups/dnsdb.c b/src/src/lookups/dnsdb.c
index 6e2be8ae1..80cf2e62a 100644
--- a/src/src/lookups/dnsdb.c
+++ b/src/src/lookups/dnsdb.c
@@ -134,22 +134,19 @@ dnsdb_find(void * handle, const uschar * filename, const uschar * keystring,
  int length, uschar ** result, uschar ** errmsg, uint * do_cache,
  const uschar * opts)
 {
-int rc;
-int sep = 0;
 int defer_mode = PASS, dnssec_mode = PASS;
-int save_retrans = dns_retrans, save_retry =   dns_retry;
-int type;
-int failrc = FAIL;
+int save_retrans = dns_retrans, save_retry = dns_retry;
+int sep = 0, rc, type, failrc = FAIL;
 const uschar * outsep = CUS"\n", * outsep2 = NULL;
 uschar * equals, * domain, * found;
 
-dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_answer * dnsa = store_get_dns_answer();	/*TTT alloc */
+dns_scan dnss = {0};
 
 /* Because we're working in the search pool, we try to reclaim as much
 store as possible later, so we preallocate the result here */
 
-gstring * yield = string_get(256);
+gstring * yield = string_get_tainted(256, GET_TAINTED);	/*TTT alloc*/
 
 /* If the string starts with '>' we change the output separator.
 If it's followed by ';' or ',' we set the TXT output separator. */
@@ -406,6 +403,7 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	  remain = rr->size - ++data_offset;
 	  if (chunk_len > remain)
 	    chunk_len = remain;
+	  /*TTT*/
 	  yield = string_catn(yield, US ((rr->data) + data_offset), chunk_len);
 	  data_offset += chunk_len;
 
@@ -430,6 +428,7 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 
 	  if (payload_length > MAX_TLSA_EXPANDED_SIZE)
 	    payload_length = MAX_TLSA_EXPANDED_SIZE;
+	  /*TTT*/
 	  yield = string_fmt_append(yield, "%d%c%d%c%d%c%.*H",
 				      usage, *outsep2,
 				      selector, *outsep2,
@@ -439,9 +438,15 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
       else   /* T_CNAME, T_CSA, T_MX, T_MXH, T_NS, T_PTR, T_SOA, T_SRV */
         {
         int priority, weight, port;
-        uschar s[264];
         uschar * p = US rr->data;
 
+	/* NB: this memory is released implicitly by the call
+	gstring_release_unused(yield) below. We used to use a stack-auto, but
+	I want to track taint wherever possible. The dnsa is not (yet)
+	allocated using taint-marked memory. */
+#define LCL_BUF_SIZE 264
+	uschar * buf = store_get(LCL_BUF_SIZE, GET_TAINTED);
+
 	switch (type)
 	  {
 	  case T_MXH:
@@ -453,8 +458,7 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	  case T_MX:
 	    if (rr_bad_size(rr, sizeof(uint16_t))) continue;
 	    GETSHORT(priority, p);
-	    sprintf(CS s, "%d%c", priority, *outsep2);
-	    yield = string_cat(yield, s);
+	    yield = string_fmt_append(yield, "%d%c", priority, *outsep2);
 	    break;
 
 	  case T_SRV:
@@ -462,9 +466,8 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	    GETSHORT(priority, p);
 	    GETSHORT(weight, p);
 	    GETSHORT(port, p);
-	    sprintf(CS s, "%d%c%d%c%d%c", priority, *outsep2,
+	    yield = string_fmt_append(yield, "%d%c%d%c%d%c", priority, *outsep2,
 			      weight, *outsep2, port, *outsep2);
-	    yield = string_cat(yield, s);
 	    break;
 
 	  case T_CSA:
@@ -481,20 +484,18 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	    authorization status in the weight field. */
 
 	    if (Ustrcmp(found, domain) != 0)
-	      {
-	      if (port & 1) *s = 'X';         /* explicit authorization required */
-	      else *s = '?';                  /* no subdomain assertions here */
-	      }
+	      yield = string_catn(yield, port & 1
+				  ? US"X " /* explicit authorization required */
+				  : US"? ", /* no subdomain assertions here */
+				  2);
+	    else if (weight > 3)
+	      continue;
 	    else
-	      {
-	      if (weight < 2) *s = 'N';       /* not authorized */
-	      else if (weight == 2) *s = 'Y'; /* authorized */
-	      else if (weight == 3) *s = '?'; /* unauthorizable */
-	      else continue;                  /* invalid */
-	      }
-
-	    s[1] = ' ';
-	    yield = string_catn(yield, s, 2);
+	      yield = string_catn(yield,
+				    weight < 2  ? US"N "  /* not authorized */
+				  : weight == 2 ? US"Y "  /* authorized */
+				  :		  US"? ", /* unauthorizable */
+				  2);
 	    break;
 
 	  default:
@@ -503,8 +504,9 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 
         /* GETSHORT() has advanced the pointer to the target domain. */
 
+	/*TTT*/
         rc = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, p,
-          (DN_EXPAND_ARG4_TYPE)s, sizeof(s));
+          (DN_EXPAND_ARG4_TYPE)buf, LCL_BUF_SIZE);
 
         /* If an overlong response was received, the data will have been
         truncated and dn_expand may fail. */
@@ -515,7 +517,7 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
             "domain=%s", dns_text_type(type), domain);
           break;
           }
-        else yield = string_cat(yield, s);
+        else yield = string_cat(yield, buf);
 
 	if (type == T_SOA && outsep2 != NULL)
 	  {
@@ -524,15 +526,16 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	  p += rc;
 	  yield = string_catn(yield, outsep2, 1);
 
+	  /*TTT*/
 	  rc = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, p,
-	    (DN_EXPAND_ARG4_TYPE)s, sizeof(s));
+	    (DN_EXPAND_ARG4_TYPE)buf, LCL_BUF_SIZE);
 	  if (rc < 0)
 	    {
 	    log_write(0, LOG_MAIN, "responsible-mailbox truncated: type=%s "
 	      "domain=%s", dns_text_type(type), domain);
 	    break;
 	    }
-	  else yield = string_cat(yield, s);
+	  else yield = string_cat(yield, buf);
 
 	  p += rc;
 	  if (!rr_bad_increment(rr, p, 5 * sizeof(uint32_t)))
@@ -540,12 +543,12 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	    GETLONG(serial, p); GETLONG(refresh, p);
 	    GETLONG(retry,  p); GETLONG(expire,  p); GETLONG(minimum, p);
 	    }
-	  sprintf(CS s, "%c%lu%c%lu%c%lu%c%lu%c%lu",
+	  yield = string_fmt_append(yield, "%c%lu%c%lu%c%lu%c%lu%c%lu",
 	    *outsep2, serial, *outsep2, refresh,
 	    *outsep2, retry,  *outsep2, expire,  *outsep2, minimum);
-	  yield = string_cat(yield, s);
 	  }
         }
+#undef LCL_BUF_SIZE
       }    /* Loop for list of returned records */
 
            /* Loop for set of A-lookup types */
@@ -564,7 +567,7 @@ dns_retrans = save_retrans;
 dns_retry = save_retry;
 dns_init(FALSE, FALSE, FALSE);	/* clear the dnssec bit for getaddrbyname */
 
-if (!yield || !yield->ptr)
+if (gstring_length(yield) == 0)
   rc = failrc;
 else
   {
diff --git a/src/src/miscmods/dkim.c b/src/src/miscmods/dkim.c
index ccb649ca1..4bd87bbf9 100644
--- a/src/src/miscmods/dkim.c
+++ b/src/src/miscmods/dkim.c
@@ -81,9 +81,9 @@ static uschar *
 dkim_exim_query_dns_txt(const uschar * name)
 {
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 rmark reset_point = store_mark();
-gstring * g = string_get_tainted(256, GET_TAINTED);
+gstring * g = string_get_tainted(256, GET_TAINTED);	/*TTT alloc*/
 
 lookup_dnssec_authenticated = NULL;
 if (dns_lookup(dnsa, name, T_TXT, NULL) != DNS_SUCCEED)
@@ -100,6 +100,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
       {
       uschar len = rr->data[rr_offset++];
 
+      /*TTT*/
       g = string_catn(g, US(rr->data + rr_offset), len);
       if (g->ptr >= PDKIM_DNS_TXT_MAX_RECLEN)
 	goto bad;
diff --git a/src/src/miscmods/dmarc_common.c b/src/src/miscmods/dmarc_common.c
index d6e27c892..1669d8400 100644
--- a/src/src/miscmods/dmarc_common.c
+++ b/src/src/miscmods/dmarc_common.c
@@ -228,7 +228,7 @@ const uschar *
 dmarc_dns_lookup(const uschar * dom)
 {
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 const uschar * res = NULL;
 
 expand_level++;
@@ -256,7 +256,7 @@ if (dns_lookup(dnsa, string_sprintf("_dmarc.%s", dom), T_TXT, NULL)
     if (  rr->type == T_TXT && len > 9
        && Ustrncmp(rdata, "v=DMARC1;", 9) == 0)
       if (!res)
-	res = string_copyn_taint(rdata, len, GET_TAINTED);
+	res = string_copyn_taint(rdata, len, GET_TAINTED);	/*XXX*/
       else
 /* RFC 7489 6.6.3 step 5: multiple records are treated as no record */
 	{
diff --git a/src/src/miscmods/spf.c b/src/src/miscmods/spf.c
index 4febe7f4e..d97995d56 100644
--- a/src/src/miscmods/spf.c
+++ b/src/src/miscmods/spf.c
@@ -67,7 +67,7 @@ SPF_dns_exim_lookup(SPF_dns_server_t *spf_dns_server,
   const char *domain, ns_type rr_type, int should_cache)
 {
 dns_answer * dnsa = store_get_dns_answer();
-dns_scan dnss;
+dns_scan dnss = {0};
 SPF_dns_rr_t * spfrr;
 unsigned found = 0;
 
@@ -134,9 +134,16 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	s += 2;	/* skip the MX precedence field */
       case T_PTR:
 	{
-	uschar * buf = store_malloc(256);
-	(void)dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, s,
-	  (DN_EXPAND_ARG4_TYPE)buf, 256);
+	/* We lose taint-tracking here, really just assuming the data
+	given to the spf library will never leak back out.  Not sure if
+	the lib assumes it can free this (it does for srr.rr) - meaning we
+	cannot use pool store. The use of malloc also for T_TXT implies so. */
+
+	uschar * buf = store_malloc(256);	/*TTT alloc*/
+	/*TTT*/
+	if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, s,
+	    (DN_EXPAND_ARG4_TYPE)buf, 256) < 0)
+	  continue;
 	s = buf;
 	break;
 	}
@@ -160,12 +167,13 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	  if (  !(chunk_len = s[offset++])
 	     || rr->size < offset + chunk_len	/* ignore bogus size chunks */
 	     ) break;
-	  g = string_catn(g, s+offset , chunk_len);
+	  g = string_catn(g, s+offset , chunk_len);	/*TTT*/
 	  }
 	if (!g)
 	  continue;
+	s = string_copy_malloc(string_from_gstring(g));	/*TTT*/
+	gstring_reset(g);
 	gstring_release_unused(g);
-	s = string_copy_malloc(string_from_gstring(g));
 	DEBUG(D_receive) debug_printf_indent("SPF_dns_exim_lookup '%s'\n", s);
 	break;
 	}
@@ -174,7 +182,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
       case T_AAAA:
       default:
 	{
-	uschar * buf = store_malloc(dnsa->answerlen + 1);
+	uschar * buf = store_malloc(dnsa->answerlen + 1);	/*TTT alloc*/
 	s = memcpy(buf, s, dnsa->answerlen + 1);
 	break;
 	}
diff --git a/src/src/string.c b/src/src/string.c
index 472008382..4e122a97b 100644
--- a/src/src/string.c
+++ b/src/src/string.c
@@ -618,9 +618,10 @@ Returns:    copy of string in new store, de-escaped
 */
 
 uschar *
-string_copy_dnsdomain(uschar * s)
+string_copy_dnsdomain(const uschar * s)
 {
 uschar * yield;
+/*TTT*/
 uschar * ss = yield = store_get(Ustrlen(s) + 1, GET_TAINTED);	/* always treat as tainted */
 
 while (*s)
diff --git a/src/src/structs.h b/src/src/structs.h
index a6261afcb..22a4bba90 100644
--- a/src/src/structs.h
+++ b/src/src/structs.h
@@ -760,11 +760,11 @@ typedef struct search_cache {
 uncompressed, but the data pointer is into the raw data. */
 
 typedef struct {
-  uschar        name[DNS_MAXNAME];      /* domain name */
-  int           type;                   /* record type */
-  unsigned short ttl;		        /* time-to-live, seconds */
-  int           size;                   /* size of data */
-  const uschar *data;                   /* pointer to data */
+  uschar       *name;			/* domain name */
+  int           type;			/* record type */
+  unsigned short ttl;			/* time-to-live, seconds */
+  int           size;			/* size of data */
+  const uschar *data;			/* pointer to data */
 } dns_record;
 
 /* Structure for holding the result of a DNS query.  A touch over
@@ -826,6 +826,9 @@ typedef struct {
 
 #ifdef SUPPORT_DANE
   BOOL			dane:1;		/* TLSA says connection must do dane */
+  /*TTT alloc*/
+  /* Strictly, this should use tainted mem. Also, is rather large - 64k - so
+  perhaps should be allocated only when needed (for DANE)? */
   dns_answer		tlsa_dnsa;	/* strictly, this should use tainted mem */
 #endif
 } smtp_connect_args;
diff --git a/src/src/tls-gnu.c b/src/src/tls-gnu.c
index b78c33fcb..1610387d9 100644
--- a/src/src/tls-gnu.c
+++ b/src/src/tls-gnu.c
@@ -3397,7 +3397,7 @@ after verification is done.*/
 static BOOL
 dane_tlsa_load(exim_gnutls_state_st * state, const dns_answer * dnsa)
 {
-dns_scan dnss;
+dns_scan dnss = {0};
 int i;
 const char **	dane_data;
 int *		dane_data_len;
@@ -3416,7 +3416,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
     ) if (rr->type == T_TLSA && rr->size > 3)
   {
   const uschar * p = rr->data;
-/*XXX need somehow to mark rr and its data as tainted.  Doues this mean copying it? */
+/*XXX need somehow to mark rr and its data as tainted.  Doues this mean copying it? *//*TTT*/
   uint8_t usage = p[0], sel = p[1], type = p[2];
 
   DEBUG(D_tls)
@@ -3438,7 +3438,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
     }
 
   tls_out.tlsa_usage |= 1<<usage;
-  dane_data[i] = CS p;
+  dane_data[i] = CS p;			/*TTT*/
   dane_data_len[i++] = rr->size;
   }
 
diff --git a/src/src/tls-openssl.c b/src/src/tls-openssl.c
index eea1f15d3..40acee7a3 100644
--- a/src/src/tls-openssl.c
+++ b/src/src/tls-openssl.c
@@ -3940,7 +3940,7 @@ static int
 dane_tlsa_load(SSL * ssl, const host_item * host, const dns_answer * dnsa,
   uschar ** errstr)
 {
-dns_scan dnss;
+dns_scan dnss = {0};
 const char * hostnames[2] = { CS host->name, NULL };
 int found = 0;
 
@@ -3972,6 +3972,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
     }
 
   found++;
+  /*TTT*/
   switch (DANESSL_add_tlsa(ssl, usage, selector, mdname, p, rr->size - 3))
     {
     default:
diff --git a/src/src/tls.c b/src/src/tls.c
index dd82c7156..041cca5e9 100644
--- a/src/src/tls.c
+++ b/src/src/tls.c
@@ -879,7 +879,10 @@ tls_client_adjunct_start(host_item * host, client_conn_ctx * cctx,
 {
 union sockaddr_46 interface_sock;
 EXIM_SOCKLEN_T size = sizeof(interface_sock);
+
+/* Large (64k if DANE supported) */
 smtp_connect_args conn_args = {.host = host };
+
 tls_support tls_dummy = { .sni = NULL };
 uschar * errstr;
 
diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index 7160f0616..1f2161ae2 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -4045,8 +4045,11 @@ int yield = OK;
 int save_errno;
 int rc;
 
-uschar *message = NULL;
-smtp_context * sx = store_get(sizeof(*sx), GET_TAINTED);	/* tainted, for the data buffers */
+uschar * message = NULL;
+
+/* Large (12k, 66k if DANE supported).  Tainted, for the data buffers */
+smtp_context * sx = store_get(sizeof(*sx), GET_TAINTED);
+
 BOOL pass_message = FALSE;
 #ifndef DISABLE_ESMTP_LIMITS
 BOOL mail_limit = FALSE;
@@ -5346,7 +5349,7 @@ smtp_transport_closedown(transport_instance * tblock)
 {
 const smtp_transport_options_block * ob = tblock->drinst.options_block;
 client_conn_ctx cctx;
-smtp_context sx = {0};
+smtp_context sx = {0};		/* Large (12k, 66k if DANE supported) */
 uschar buffer[256];
 uschar inbuffer[4096];
 uschar outbuffer[16];
@@ -5381,7 +5384,7 @@ int
 smtp_write_atrn(address_item * addr, cut_t * cutp)
 {
 const smtp_transport_options_block * ob = addr->transport->drinst.options_block;
-smtp_context sx = {0};
+smtp_context sx = {0};		/* Large (12k, 66k if DANE supported */
 uschar buffer[256];
 uschar inbuffer[4096];
 uschar outbuffer[256];
diff --git a/src/src/transports/smtp.h b/src/src/transports/smtp.h
index 49e3c8b96..506d6094a 100644
--- a/src/src/transports/smtp.h
+++ b/src/src/transports/smtp.h
@@ -144,7 +144,7 @@ typedef struct {
   const uschar *	from_addr;
   address_item *	addrlist;
 
-  smtp_connect_args	conn_args;
+  smtp_connect_args	conn_args;	/* Large (if DANE supported) */
   int			port;
 
   BOOL verify:1;
diff --git a/src/src/transports/smtp_socks.c b/src/src/transports/smtp_socks.c
index 436674e9b..c17b808e9 100644
--- a/src/src/transports/smtp_socks.c
+++ b/src/src/transports/smtp_socks.c
@@ -258,6 +258,8 @@ for(;;)
   {
   int idx;
   host_item proxy;
+
+  /* Large (64k if DANE supported) */
   smtp_connect_args proxy_sc = {.sock = -1};
 
   if ((idx = socks_get_proxy(proxies, nproxies)) < 0)
diff --git a/src/src/verify.c b/src/src/verify.c
index 18c53c1e8..6696ec4d9 100644
--- a/src/src/verify.c
+++ b/src/src/verify.c
@@ -16,7 +16,7 @@ caching was contributed by Kevin Fleming (but I hacked it around a bit). */
 
 #define CUTTHROUGH_CMD_TIMEOUT  30	/* timeout for cutthrough-routing calls */
 #define CUTTHROUGH_DATA_TIMEOUT 60	/* timeout for cutthrough-routing calls */
-static smtp_context ctctx;
+static smtp_context ctctx;		/* Large (12k, 66k if DANE supported */
 uschar ctbuffer[8192];
 
 
@@ -703,7 +703,8 @@ coding means skipping this whole loop and doing the append separately.  */
       log_write(0, LOG_MAIN|LOG_PANIC, "<%s>: %s", addr->address,
         addr->message);
 
-    if (!sx) sx = store_get(sizeof(*sx), GET_TAINTED);	/* tainted buffers */
+    /* Large (12k, 66k if DANE supported.  Tainted, for the receive buffers */
+    if (!sx) sx = store_get(sizeof(*sx), GET_TAINTED);
     memset(sx, 0, sizeof(*sx));
 
     sx->addrlist = sx->first_addr = addr;
@@ -1417,7 +1418,7 @@ Used for
 static uschar
 cutthrough_response(client_conn_ctx * cctx, char expect, uschar ** copy, int timeout)
 {
-smtp_context sx = {0};
+smtp_context sx = {0};		/* Large (12k, 66k if DANE supported) */
 uschar inbuffer[4096];
 uschar responsebuffer[4096];
 

